Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 9169)
@@ -13,11 +13,12 @@
    USE oce_trc         !
    USE trc             ! 
-   USE sms_pisces
-   USE p2zopt
+   USE sms_pisces      !
+   USE p2zopt          !
+   USE trd_oce         !
+   USE trdtrc          !
+   !
    USE lbclnk          ! 
    USE prtctl_trc      ! Print control for debbuging
-   USE trd_oce
-   USE trdtrc
-   USE iom
+   USE iom             !
    
    IMPLICIT NONE
@@ -83,7 +84,6 @@
       !!        
       !!---------------------------------------------------------------------
-      !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
-      !!
+      !
       INTEGER  ::   ji, jj, jk, jl
       REAL(wp) ::   zdet, zzoo, zphy, zno3, znh4, zdom      ! now concentrations
@@ -96,6 +96,6 @@
       REAL(wp) ::   znh4a, zdeta, zdoma, zzoobod, zboddet, zdomaju
       REAL(wp) ::   ze3t
-      REAL(wp), ALLOCATABLE,   DIMENSION(:,:,:) :: zw2d
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) :: zw3d
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   zw2d
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   zw3d
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -103,5 +103,5 @@
       IF( ln_timing )   CALL timing_start('p2z_bio')
       !
-      IF( lk_iomput ) ALLOCATE( zw2d(jpi,jpj,17), zw3d(jpi,jpj,jpk,3) )
+      IF( lk_iomput )   ALLOCATE( zw2d(jpi,jpj,17), zw3d(jpi,jpj,jpk,3) )
 
       IF( kt == nittrc000 ) THEN
@@ -113,6 +113,6 @@
       xksi(:,:) = 0.e0        ! zooplakton closure ( fbod)
       IF( lk_iomput ) THEN
-         zw2d  (:,:,:) = 0.e0
-         zw3d(:,:,:,:) = 0.e0
+         zw2d  (:,:,:) = 0._wp
+         zw3d(:,:,:,:) = 0._wp
       ENDIF
 
@@ -311,6 +311,5 @@
                tra(ji,jj,jk,jpdom) = tra(ji,jj,jk,jpdom) + zdoma
                !
-                IF( lk_iomput ) THEN
-                  ! convert fluxes in per day
+                IF( lk_iomput ) THEN                  ! convert fluxes in per day
                   ze3t = e3t_n(ji,jj,jk) * 86400._wp
                   zw2d(ji,jj,1)  = zw2d(ji,jj,1)  + zno3phy * ze3t
@@ -335,34 +334,34 @@
                   zw3d(ji,jj,jk,2) = znh4phy * 86400._wp
                   zw3d(ji,jj,jk,3) = znh4no3 * 86400._wp
-                   !
-                ENDIF
+                  !
+               ENDIF
             END DO
          END DO
       END DO
-
+      !
       IF( lk_iomput ) THEN
-        CALL lbc_lnk( zw2d(:,:,:),'T', 1. )
-        CALL lbc_lnk_multi( zw3d(:,:,:,1),'T', 1., zw3d(:,:,:,2),'T', 1., zw3d(:,:,:,3),'T', 1. )
-        ! Save diagnostics
-        CALL iom_put( "TNO3PHY", zw2d(:,:,1) )
-        CALL iom_put( "TNH4PHY", zw2d(:,:,2) )
-        CALL iom_put( "TPHYDOM", zw2d(:,:,3) )
-        CALL iom_put( "TPHYNH4", zw2d(:,:,4) )
-        CALL iom_put( "TPHYZOO", zw2d(:,:,5) )
-        CALL iom_put( "TPHYDET", zw2d(:,:,6) )
-        CALL iom_put( "TDETZOO", zw2d(:,:,7) )
-        CALL iom_put( "TZOODET", zw2d(:,:,8) )
-        CALL iom_put( "TZOOBOD", zw2d(:,:,9) )
-        CALL iom_put( "TZOONH4", zw2d(:,:,10) )
-        CALL iom_put( "TZOODOM", zw2d(:,:,11) )
-        CALL iom_put( "TNH4NO3", zw2d(:,:,12) )
-        CALL iom_put( "TDOMNH4", zw2d(:,:,13) )
-        CALL iom_put( "TDETNH4", zw2d(:,:,14) )
-        CALL iom_put( "TPHYTOT", zw2d(:,:,15) )
-        CALL iom_put( "TZOOTOT", zw2d(:,:,16) )
+         CALL lbc_lnk( zw2d(:,:,:),'T', 1. )
+         CALL lbc_lnk_multi( zw3d(:,:,:,1),'T', 1., zw3d(:,:,:,2),'T', 1., zw3d(:,:,:,3),'T', 1. )
+         ! Save diagnostics
+         CALL iom_put( "TNO3PHY", zw2d(:,:,1) )
+         CALL iom_put( "TNH4PHY", zw2d(:,:,2) )
+         CALL iom_put( "TPHYDOM", zw2d(:,:,3) )
+         CALL iom_put( "TPHYNH4", zw2d(:,:,4) )
+         CALL iom_put( "TPHYZOO", zw2d(:,:,5) )
+         CALL iom_put( "TPHYDET", zw2d(:,:,6) )
+         CALL iom_put( "TDETZOO", zw2d(:,:,7) )
+         CALL iom_put( "TZOODET", zw2d(:,:,8) )
+         CALL iom_put( "TZOOBOD", zw2d(:,:,9) )
+         CALL iom_put( "TZOONH4", zw2d(:,:,10) )
+         CALL iom_put( "TZOODOM", zw2d(:,:,11) )
+         CALL iom_put( "TNH4NO3", zw2d(:,:,12) )
+         CALL iom_put( "TDOMNH4", zw2d(:,:,13) )
+         CALL iom_put( "TDETNH4", zw2d(:,:,14) )
+         CALL iom_put( "TPHYTOT", zw2d(:,:,15) )
+         CALL iom_put( "TZOOTOT", zw2d(:,:,16) )
          ! 
-        CALL iom_put( "FNO3PHY", zw3d(:,:,:,1) )
-        CALL iom_put( "FNH4PHY", zw3d(:,:,:,2) )
-        CALL iom_put( "FNH4NO3", zw3d(:,:,:,3) )
+         CALL iom_put( "FNO3PHY", zw3d(:,:,:,1) )
+         CALL iom_put( "FNH4PHY", zw3d(:,:,:,2) )
+         CALL iom_put( "FNH4NO3", zw3d(:,:,:,3) )
          !
       ENDIF
@@ -374,5 +373,5 @@
       ENDIF
       !
-      IF( lk_iomput ) DEALLOCATE( zw2d, zw3d )
+      IF( lk_iomput )   DEALLOCATE( zw2d, zw3d )
       !
       IF( ln_timing )  CALL timing_stop('p2z_bio')
@@ -390,101 +389,100 @@
       !!
       !!----------------------------------------------------------------------
+      INTEGER ::   ios   ! Local integer
+      !!
       NAMELIST/namlobphy/ tmumax, rgamma, fphylab, tmminp, aki
       NAMELIST/namlobnut/ akno3, aknh4, taunn, psinut
       NAMELIST/namlobzoo/ rppz, taus, aks, rpnaz, rdnaz, tauzn, fzoolab, fdbod, tmminz
-      NAMELIST/namlobdet/  taudn, fdetlab
+      NAMELIST/namlobdet/ taudn, fdetlab
       NAMELIST/namlobdom/ taudomn
-      INTEGER :: ios                 ! Local integer output status for namelist read
       !!----------------------------------------------------------------------
-
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' p2z_bio_init : LOBSTER bio-model initialization'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~'
+      !
       REWIND( numnatp_ref )              ! Namelist namlobphy in reference namelist : Lobster biological parameters
       READ  ( numnatp_ref, namlobphy, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobphy in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlobphy in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobphy in configuration namelist : Lobster biological parameters
       READ  ( numnatp_cfg, namlobphy, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobphy in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobphy in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobphy )
-
+      !
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobphy'
-          WRITE(numout,*) '    phyto max growth rate                                tmumax    =', 86400 * tmumax, ' d'
-          WRITE(numout,*) '    phytoplankton exudation fraction                     rgamma    =', rgamma
-          WRITE(numout,*) '    NH4 fraction of phytoplankton exsudation             fphylab   =', fphylab
-          WRITE(numout,*) '    minimal phyto mortality rate                         tmminp    =', 86400 * tmminp
-          WRITE(numout,*) '    light hlaf saturation constant                       aki       =', aki
-          WRITE(numout,*) ' '
+         WRITE(numout,*) '   Namelist namlobphy'
+         WRITE(numout,*) '      phyto max growth rate                                tmumax    =', 86400 * tmumax, ' d'
+         WRITE(numout,*) '      phytoplankton exudation fraction                     rgamma    =', rgamma
+         WRITE(numout,*) '      NH4 fraction of phytoplankton exsudation             fphylab   =', fphylab
+         WRITE(numout,*) '      minimal phyto mortality rate                         tmminp    =', 86400 * tmminp
+         WRITE(numout,*) '      light hlaf saturation constant                       aki       =', aki
       ENDIF
 
       REWIND( numnatp_ref )              ! Namelist namlobnut in reference namelist : Lobster nutriments parameters
       READ  ( numnatp_ref, namlobnut, IOSTAT = ios, ERR = 903)
-903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobnut in reference namelist', lwp )
-
+903   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlobnut in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobnut in configuration namelist : Lobster nutriments parameters
       READ  ( numnatp_cfg, namlobnut, IOSTAT = ios, ERR = 904 )
-904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobnut in configuration namelist', lwp )
+904   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobnut in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobnut )
 
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobnut'
-          WRITE(numout,*) '    half-saturation nutrient for no3 uptake              akno3     =', akno3
-          WRITE(numout,*) '    half-saturation nutrient for nh4 uptake              aknh4     =', aknh4
-          WRITE(numout,*) '    nitrification rate                                   taunn     =', taunn
-          WRITE(numout,*) '    inhibition of no3 uptake by nh4                      psinut    =', psinut
-          WRITE(numout,*) ' '
+         WRITE(numout,*) 
+         WRITE(numout,*) '   Namelist namlobnut'
+         WRITE(numout,*) '      half-saturation nutrient for no3 uptake              akno3     =', akno3
+         WRITE(numout,*) '      half-saturation nutrient for nh4 uptake              aknh4     =', aknh4
+         WRITE(numout,*) '      nitrification rate                                   taunn     =', taunn
+         WRITE(numout,*) '      inhibition of no3 uptake by nh4                      psinut    =', psinut
       ENDIF
 
       REWIND( numnatp_ref )              ! Namelist namlobzoo in reference namelist : Lobster zooplankton parameters
       READ  ( numnatp_ref, namlobzoo, IOSTAT = ios, ERR = 905)
-905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobzoo in reference namelist', lwp )
-
+905   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlobzoo in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobzoo in configuration namelist : Lobster zooplankton parameters
       READ  ( numnatp_cfg, namlobzoo, IOSTAT = ios, ERR = 906 )
-906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobzoo in configuration namelist', lwp )
+906   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobzoo in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobzoo )
 
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobzoo'
-          WRITE(numout,*) '    zoo preference for phyto                             rppz      =', rppz
-          WRITE(numout,*) '    maximal zoo grazing rate                             taus      =', 86400 * taus, ' d'
-          WRITE(numout,*) '    half saturation constant for zoo food                aks       =', aks
-          WRITE(numout,*) '    non-assimilated phyto by zoo                         rpnaz     =', rpnaz
-          WRITE(numout,*) '    non-assimilated detritus by zoo                      rdnaz     =', rdnaz
-          WRITE(numout,*) '    zoo specific excretion rate                          tauzn     =', 86400 * tauzn
-          WRITE(numout,*) '    minimal zoo mortality rate                           tmminz    =', 86400 * tmminz
-          WRITE(numout,*) '    NH4 fraction of zooplankton excretion                fzoolab   =', fzoolab
-          WRITE(numout,*) '    Zooplankton mortality fraction that goes to detritus fdbod     =', fdbod
-          WRITE(numout,*) ' '
+         WRITE(numout,*) 
+         WRITE(numout,*) '   Namelist namlobzoo'
+         WRITE(numout,*) '      zoo preference for phyto                             rppz      =', rppz
+         WRITE(numout,*) '      maximal zoo grazing rate                             taus      =', 86400 * taus, ' d'
+         WRITE(numout,*) '      half saturation constant for zoo food                aks       =', aks
+         WRITE(numout,*) '      non-assimilated phyto by zoo                         rpnaz     =', rpnaz
+         WRITE(numout,*) '      non-assimilated detritus by zoo                      rdnaz     =', rdnaz
+         WRITE(numout,*) '      zoo specific excretion rate                          tauzn     =', 86400 * tauzn
+         WRITE(numout,*) '      minimal zoo mortality rate                           tmminz    =', 86400 * tmminz
+         WRITE(numout,*) '      NH4 fraction of zooplankton excretion                fzoolab   =', fzoolab
+         WRITE(numout,*) '      Zooplankton mortality fraction that goes to detritus fdbod     =', fdbod
       ENDIF
 
       REWIND( numnatp_ref )              ! Namelist namlobdet in reference namelist : Lobster detritus parameters
       READ  ( numnatp_ref, namlobdet, IOSTAT = ios, ERR = 907)
-907   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobdet in reference namelist', lwp )
-
+907   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlobdet in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobdet in configuration namelist : Lobster detritus parameters
       READ  ( numnatp_cfg, namlobdet, IOSTAT = ios, ERR = 908 )
-908   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobdet in configuration namelist', lwp )
+908   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobdet in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobdet )
 
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobdet'
-          WRITE(numout,*) '    detrital breakdown rate                              taudn     =', 86400 * taudn , ' d'
-          WRITE(numout,*) '    NH4 fraction of detritus dissolution                 fdetlab   =', fdetlab
-          WRITE(numout,*) ' '
+          WRITE(numout,*) 
+          WRITE(numout,*) '   Namelist namlobdet'
+          WRITE(numout,*) '      detrital breakdown rate                              taudn     =', 86400 * taudn , ' d'
+          WRITE(numout,*) '      NH4 fraction of detritus dissolution                 fdetlab   =', fdetlab
       ENDIF
 
       REWIND( numnatp_ref )              ! Namelist namlobdom in reference namelist : Lobster DOM breakdown rate
       READ  ( numnatp_ref, namlobdom, IOSTAT = ios, ERR = 909)
-909   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobdom in reference namelist', lwp )
-
+909   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlobdom in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobdom in configuration namelist : Lobster DOM breakdown rate
       READ  ( numnatp_cfg, namlobdom, IOSTAT = ios, ERR = 910 )
-910   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobdom in configuration namelist', lwp )
+910   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobdom in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobdom )
 
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobdom'
-          WRITE(numout,*) '    DOM breakdown rate                                 taudomn     =', 86400 * taudn , ' d'
-          WRITE(numout,*) ' '
+          WRITE(numout,*) 
+          WRITE(numout,*) '   Namelist namlobdom'
+          WRITE(numout,*) '      DOM breakdown rate                                 taudomn     =', 86400 * taudn , ' d'
       ENDIF
       !
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 9169)
@@ -11,10 +11,11 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trc
-   USE sms_pisces
-   USE lbclnk
-   USE trd_oce
-   USE trdtrc
-   USE iom
+   USE trd_oce         !
+   USE trdtrc          !
+   USE trc             !
+   USE sms_pisces      !
+   !
+   USE lbclnk          !
+   USE iom             !
    USE prtctl_trc      ! Print control for debbuging
 
@@ -26,7 +27,7 @@
 
    REAL(wp), PUBLIC ::   sedlam      !: time coefficient of POC remineralization in sediments
-   REAL(wp), PUBLIC ::   sedlostpoc  ! mass of POC lost in sediments 
-   REAL(wp), PUBLIC ::   vsed        ! detritus sedimentation speed [m/s] 
-   REAL(wp), PUBLIC ::   xhr         ! coeff for martin''s remineralisation profile
+   REAL(wp), PUBLIC ::   sedlostpoc  !: mass of POC lost in sediments 
+   REAL(wp), PUBLIC ::   vsed        !: detritus sedimentation speed [m/s] 
+   REAL(wp), PUBLIC ::   xhr         !: coeff for martin''s remineralisation profile
 
    !!----------------------------------------------------------------------
@@ -126,22 +127,23 @@
       !!
       !!----------------------------------------------------------------------
+      INTEGER ::   ios   ! Local integer
+      !!
       NAMELIST/namlobsed/ sedlam, sedlostpoc, vsed, xhr
-      INTEGER :: ios                 ! Local integer output status for namelist read
-
+      !!----------------------------------------------------------------------
+      !
       REWIND( numnatp_ref )              ! Namelist namlobsed in reference namelist : Lobster sediments
       READ  ( numnatp_ref, namlobsed, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlosed in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namlosed in reference namelist', lwp )
       REWIND( numnatp_cfg )              ! Namelist namlobsed in configuration namelist : Lobster sediments
       READ  ( numnatp_cfg, namlobsed, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namlobsed in configuration namelist', lwp )
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namlobsed in configuration namelist', lwp )
       IF(lwm) WRITE ( numonp, namlobsed )
-
+      !
       IF(lwp) THEN
-          WRITE(numout,*) ' Namelist namlobsed'
-          WRITE(numout,*) '    time coeff of POC in sediments                       sedlam    =', sedlam
-          WRITE(numout,*) '    Sediment geol loss for POC                           sedlostpoc=', sedlostpoc
-          WRITE(numout,*) '    detritus sedimentation speed                         vsed      =', 86400 * vsed  , ' d'
-          WRITE(numout,*) '    coeff for martin''s remineralistion                  xhr       =', xhr
+          WRITE(numout,*) '   Namelist namlobsed'
+          WRITE(numout,*) '      time coeff of POC in sediments                sedlam    =', sedlam
+          WRITE(numout,*) '      Sediment geol loss for POC                    sedlostpoc=', sedlostpoc
+          WRITE(numout,*) '      detritus sedimentation speed                  vsed      =', 86400 * vsed  , ' d'
+          WRITE(numout,*) '      coeff for martin''s remineralistion           xhr       =', xhr
           WRITE(numout,*) ' '
       ENDIF
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 9125)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 9169)
@@ -7,32 +7,31 @@
    !!             3.6  !  2015-05  (O. Aumont) PISCES quota
    !!----------------------------------------------------------------------
-   !!   p4z_fechem       :  Compute remineralization/scavenging of iron
-   !!   p4z_fechem_init  :  Initialisation of parameters for remineralisation
-   !!   p4z_fechem_alloc :  Allocate remineralisation variables
+   !!   p4z_fechem       : Compute remineralization/scavenging of iron
+   !!   p4z_fechem_init  : Initialisation of parameters for remineralisation
+   !!   p4z_fechem_alloc : Allocate remineralisation variables
    !!----------------------------------------------------------------------
-   USE oce_trc         !  shared variables between ocean and passive tracers
-   USE trc             !  passive tracers common variables 
-   USE sms_pisces      !  PISCES Source Minus Sink variables
-   USE p4zche          !  chemical model
-   USE p4zsbc          !  Boundary conditions from sediments
-   USE prtctl_trc      !  print control for debugging
-   USE iom             !  I/O manager
+   USE oce_trc         ! shared variables between ocean and passive tracers
+   USE trc             ! passive tracers common variables 
+   USE sms_pisces      ! PISCES Source Minus Sink variables
+   USE p4zche          ! chemical model
+   USE p4zsbc          ! Boundary conditions from sediments
+   USE prtctl_trc      ! print control for debugging
+   USE iom             ! I/O manager
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   p4z_fechem      ! called in p4zbio.F90
-   PUBLIC   p4z_fechem_init ! called in trcsms_pisces.F90
-
-   !! * Shared module variables
-   LOGICAL          ::  ln_fechem    !: boolean for complex iron chemistry following Tagliabue and voelker
-   LOGICAL          ::  ln_ligvar    !: boolean for variable ligand concentration following Tagliabue and voelker
-   LOGICAL          ::  ln_fecolloid !: boolean for variable colloidal fraction
-   REAL(wp), PUBLIC ::  xlam1        !: scavenging rate of Iron 
-   REAL(wp), PUBLIC ::  xlamdust     !: scavenging rate of Iron by dust 
-   REAL(wp), PUBLIC ::  ligand       !: ligand concentration in the ocean 
-   REAL(wp), PUBLIC ::  kfep         !: rate constant for nanoparticle formation
-
-   REAL(wp) :: kl1, kl2, kb1, kb2, ks, kpr, spd, con, kth
+   PUBLIC   p4z_fechem        ! called in p4zbio.F90
+   PUBLIC   p4z_fechem_init   ! called in trcsms_pisces.F90
+
+   LOGICAL          ::   ln_fechem    !: boolean for complex iron chemistry following Tagliabue and voelker
+   LOGICAL          ::   ln_ligvar    !: boolean for variable ligand concentration following Tagliabue and voelker
+   LOGICAL          ::   ln_fecolloid !: boolean for variable colloidal fraction
+   REAL(wp), PUBLIC ::   xlam1        !: scavenging rate of Iron 
+   REAL(wp), PUBLIC ::   xlamdust     !: scavenging rate of Iron by dust 
+   REAL(wp), PUBLIC ::   ligand       !: ligand concentration in the ocean 
+   REAL(wp), PUBLIC ::   kfep         !: rate constant for nanoparticle formation
+
+   REAL(wp) :: kl1, kl2, kb1, kb2, ks, kpr, spd, con, kth      !!gm  <<<== DOCTOR names SVP !!!
 
    !!----------------------------------------------------------------------
@@ -56,6 +55,5 @@
       !!                    and one particulate form (ln_fechem)
       !!---------------------------------------------------------------------
-      !
-      INTEGER, INTENT(in) ::   kt, knt ! ocean time step
+      INTEGER, INTENT(in) ::   kt, knt   ! ocean time step
       !
       INTEGER  ::   ji, jj, jk, jic, jn
@@ -67,14 +65,14 @@
       REAL(wp) ::   zzFeL1, zzFeL2, zzFe2, zzFeP, zzFe3, zzstrn2
       REAL(wp) ::   zrum, zcodel, zargu, zlight
-      REAL(wp) :: zkox, zkph1, zkph2, zph, zionic, ztligand
-      REAL(wp) :: za, zb, zc, zkappa1, zkappa2, za0, za1, za2
-      REAL(wp) :: zxs, zfunc, zp, zq, zd, zr, zphi, zfff, zp3, zq2
-      REAL(wp) :: ztfe, zoxy, zhplus
-      REAL(wp) :: zaggliga, zaggligb
-      REAL(wp) :: dissol, zligco
+      REAL(wp) ::   zkox, zkph1, zkph2, zph, zionic, ztligand
+      REAL(wp) ::   za, zb, zc, zkappa1, zkappa2, za0, za1, za2
+      REAL(wp) ::   zxs, zfunc, zp, zq, zd, zr, zphi, zfff, zp3, zq2
+      REAL(wp) ::   ztfe, zoxy, zhplus
+      REAL(wp) ::   zaggliga, zaggligb
+      REAL(wp) ::   dissol, zligco
       CHARACTER (len=25) :: charout
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zTL1, zFe3, ztotlig, precip, zFeL1
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: zFeL2, zTL2, zFe2, zFeP
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:  ) :: zstrn, zstrn2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zTL1, zFe3, ztotlig, precip, zFeL1
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   zFeL2, zTL2, zFe2, zFeP
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:  ) ::   zstrn, zstrn2
       !!---------------------------------------------------------------------
       !
@@ -384,30 +382,32 @@
       NAMELIST/nampisfer/ ln_fechem, ln_ligvar, ln_fecolloid, xlam1, xlamdust, ligand, kfep 
       !!----------------------------------------------------------------------
-
-      REWIND( numnatp_ref )              ! Namelist nampisfer in reference namelist : Pisces iron chemistry
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'p4z_rem_init : Initialization of iron chemistry parameters'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+      !
+      REWIND( numnatp_ref )            ! Namelist nampisfer in reference namelist : Pisces iron chemistry
       READ  ( numnatp_ref, nampisfer, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisfer in reference namelist', lwp )
-
-      REWIND( numnatp_cfg )              ! Namelist nampisfer in configuration namelist : Pisces iron chemistry
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'nampisfer in reference namelist', lwp )
+      REWIND( numnatp_cfg )            ! Namelist nampisfer in configuration namelist : Pisces iron chemistry
       READ  ( numnatp_cfg, nampisfer, IOSTAT = ios, ERR = 902 )
-902   IF( ios >  0 ) CALL ctl_nam ( ios , 'nampisfer in configuration namelist', lwp )
-      IF(lwm) WRITE ( numonp, nampisfer )
-
-      IF(lwp) THEN                         ! control print
-         WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for Iron chemistry, nampisfer'
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    enable complex iron chemistry scheme      ln_fechem    =', ln_fechem
-         WRITE(numout,*) '    variable concentration of ligand          ln_ligvar    =', ln_ligvar
-         WRITE(numout,*) '    Variable colloidal fraction of Fe3+       ln_fecolloid =', ln_fecolloid
-         WRITE(numout,*) '    scavenging rate of Iron                   xlam1        =', xlam1
-         WRITE(numout,*) '    scavenging rate of Iron by dust           xlamdust     =', xlamdust
-         WRITE(numout,*) '    ligand concentration in the ocean         ligand       =', ligand
-         WRITE(numout,*) '    rate constant for nanoparticle formation  kfep         =', kfep
-      ENDIF
-      !
-      IF( ln_fechem ) THEN
-         ! initialization of some constants used by the complexe chemistry scheme
-         ! ----------------------------------------------------------------------
+902   IF( ios >  0 )   CALL ctl_nam ( ios , 'nampisfer in configuration namelist', lwp )
+      IF(lwm) WRITE( numonp, nampisfer )
+
+      IF(lwp) THEN                     ! control print
+         WRITE(numout,*) '   Namelist : nampisfer'
+         WRITE(numout,*) '      enable complex iron chemistry scheme      ln_fechem    =', ln_fechem
+         WRITE(numout,*) '      variable concentration of ligand          ln_ligvar    =', ln_ligvar
+         WRITE(numout,*) '      Variable colloidal fraction of Fe3+       ln_fecolloid =', ln_fecolloid
+         WRITE(numout,*) '      scavenging rate of Iron                   xlam1        =', xlam1
+         WRITE(numout,*) '      scavenging rate of Iron by dust           xlamdust     =', xlamdust
+         WRITE(numout,*) '      ligand concentration in the ocean         ligand       =', ligand
+         WRITE(numout,*) '      rate constant for nanoparticle formation  kfep         =', kfep
+      ENDIF
+      !
+      IF( ln_fechem ) THEN             ! set some constants used by the complexe chemistry scheme
+         !
          spd = 3600. * 24.
          con = 1.E9
